AlphaMetrixForms/AlphaMetrixForms.Web/Controllers/FormController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Claims;
using System.Threading.Tasks;
using AlphaMetrixForms.Services.Contracts;
using AlphaMetrixForms.Services.DTOs;
using AlphaMetrixForms.Web.AutoMapper;
using AlphaMetrixForms.Web.Models;
using AlphaMetrixForms.Web.Models.Enums;
using AlphaMetrixForms.Web.Models.Form;
using AlphaMetrixForms.Web.Models.Question;
using AutoMapper;
using Microsoft.AspNetCore.Mvc;
using System.Net.Mail;
using Microsoft.AspNetCore.Authorization;
using AlphaMetrixForms.Web.Utils;
using AlphaMetrixForms.Web.Models.Response;
using System.Text;
using AlphaMetrixForms.Web.Utils.Contracts;

namespace AlphaMetrixForms.Web.Controllers
{
    [Authorize]
    public class FormController : Controller
    {
        private readonly IFormService _formService;
        private readonly ITextQuestionService _textQuestionService;
        private readonly IOptionQuestionService _optionQuestionService;
        private readonly IDocumentQuestionService _documentQuestionService;
        private readonly IFactory _factory;
        private readonly IMapper _mapper;

        public FormController(IFormService formService, ITextQuestionService textQuestionService, IOptionQuestionService optionQuestionService,
            IDocumentQuestionService documentQuestionService, IMapper mapper, IFactory factory)
        {
            _formService = formService ?? throw new ArgumentNullException(nameof(formService));
            _textQuestionService = textQuestionService ?? throw new ArgumentNullException(nameof(textQuestionService));
            _optionQuestionService = optionQuestionService ?? throw new ArgumentNullException(nameof(optionQuestionService));
            _documentQuestionService = documentQuestionService ?? throw new ArgumentNullException(nameof(documentQuestionService));
            _factory = factory ?? throw new ArgumentNullException(nameof(factory));
            _mapper = mapper ?? throw new ArgumentNullException(nameof(mapper));
        }
        [AllowAnonymous]
        public async Task<IActionResult> Index(int? pageNumber)
        {
            var forms = await this._formService.GetAllFormsAsync();
            var formsVM = _mapper.Map<IEnumerable<FormViewModel>>(forms);

            int pageSize = 9;
            return View("Index", PaginatedList<FormViewModel>.CreateAsync(formsVM.OrderByDescending(f=>f.CreatedOn), pageNumber ?? 1, pageSize));
        }
        
        [HttpPost]
        public async Task<IActionResult> Share(EmailProvider emailList)
        {
            var result = await _formService.ShareFormAsync(emailList.Emails, emailList.FormId);
            if(result)
            {
                return Ok();
            }
            return BadRequest();
        }

        public IActionResult Create()
        {
            var model = new FormViewModel();
            return View("ModifyFormView", model);
        }


        [HttpPost]
        public async Task<IActionResult> Create(FormViewModel form)
        {
            string _errorMessage = Validator.ModifyModelValidation_Message(form);
            if (_errorMessage != null)
            {
                Response.StatusCode = (int)System.Net.HttpStatusCode.BadRequest;
                return Json(new { success = false, responseText = _errorMessage });
            }

            FormDTO formDTO = _mapper.Map<FormDTO>(form);
            Guid userId = Guid.Parse(User.FindFirstValue(ClaimTypes.NameIdentifier));

            FormDTO newForm = await _formService.CreateFormAsync(formDTO, userId);
            Guid formId = newForm.Id;

            await _factory.CreateTextQuestions(form, formId, _textQuestionService, _mapper);
            await _factory.CreateOptionQuestions(form, formId, _optionQuestionService, _mapper);
            await _factory.CreateDocumentQuestions(form, formId, _documentQuestionService, _mapper);

            return Ok();
        }

        public async Task<IActionResult> Edit(Guid id)
        {
            
            FormDTO form = await _formService.GetFormAsync(id);
            FormViewModel result = ModelGenerator.ViewModel_Generator(form, _mapper);
            result.EditMode = true;
            Questions_SetEditMode(result.Questions);
            result.Questions = result.Questions.OrderBy(q => q.OrderNumber).ToList();

            return View("ModifyFormView", result);
        }
        private void Questions_SetEditMode(ICollection<QuestionViewModel> questions)
        {
            foreach(var question in questions)
            {
                question.EditMode = true;
            }
        }
        [HttpPost]
        public async Task<IActionResult> SaveChanges(FormViewModel form)
        {
            string _errorMessage = Validator.ModifyModelValidation_Message(form);
            if (_errorMessage != null)
            {
                Response.StatusCode = (int)System.Net.HttpStatusCode.BadRequest;
                return Json(new { success = false, responseText = _errorMessage });
            }
            if (!form.EditMode)
            {
                throw new ArgumentException("Edit mode mistaken!");
            }
            FormDTO formDTO = ModelGenerator.DataTransferObject_Generator(form, _mapper);
            FormDTO updated = await _formService.UpdateFormAsync(form.Id, formDTO);
            FormViewModel result = ModelGenerator.ViewModel_Generator(updated, _mapper);
            Questions_SetEditMode(result.Questions);
            result.EditMode = true;

            if (updated == null)
            {
                throw new ArgumentException();
            }

            return View("ModifyFormView", result);
        }
        [HttpPost]
        public async Task<IActionResult> Delete(Guid id)
        {
            await _formService.DeleteFormAsync(id);
            return Ok();
        }

        [HttpPost]
        public async Task<IActionResult> DeleteQuestion(FormViewModel form)
        {
            QuestionViewModel question = form.Questions.FirstOrDefault(q => q.OrderNumber == form.Current);
            form.Questions.Remove(question);

            for (int i = 0; i < form.Questions.Count; i++)
            {
                form.Questions[i].OrderNumber = i;
            }

            return PartialView("_QuestionPartial", form);
        }

        public async Task<IActionResult> SearchForms (string title, int? pageNumber)
        {
            if(title != null)
            {
                var forms = await _formService.SearchForms(title);
                var formsVM = _mapper.Map<IEnumerable<FormViewModel>>(forms);

                int pageSize = 9;
                return View("Index", PaginatedList<FormViewModel>.CreateAsync(formsVM.OrderByDescending(f => f.CreatedOn), pageNumber ?? 1, pageSize));
            }
            return BadRequest();
        }

        [HttpPost]
        public IActionResult FormPreview(FormViewModel form)
        {
         
            foreach(var question in form.Questions)
            {
                question.PreviewMode = true;
                question.EditMode = false;
            }

            return PartialView("_PreviewFormPartial", form);
        }
    }
}

AlphaMetrixForms/AlphaMetrixForms.Web/Controllers/ResponseController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Claims;
using System.Threading.Tasks;
using AlphaMetrixForms.Services.Contracts;
using AlphaMetrixForms.Services.DTOs;
using AlphaMetrixForms.Web.Models.Enums;
using AlphaMetrixForms.Web.Models.Form;
using AlphaMetrixForms.Web.Models.Question;
using AlphaMetrixForms.Web.Models.Response;
using AlphaMetrixForms.Web.Models.User;
using AlphaMetrixForms.Web.Utils;
using AlphaMetrixForms.Web.Utils.Contracts;
using AutoMapper;
using Microsoft.AspNetCore.Mvc;

namespace AlphaMetrixForms.Web.Controllers
{
    public class ResponseController : Controller
    {
        private readonly IFormService _formService;
        private readonly ITextQuestionService _textQuestionService;
        private readonly IOptionQuestionService _optionQuestionService;
        private readonly IDocumentQuestionService _documentQuestionService;
        private readonly IResponseService _responseService;
        private readonly IFactory _factory;
        private readonly IModelGenerator _modelGenerator;
        private readonly IMapper _mapper;


        public ResponseController(IFormService formService, ITextQuestionService textQuestionService, IOptionQuestionService optionQuestionService,
            IDocumentQuestionService documentQuestionService, IResponseService responseService, IMapper mapper, IFactory factory, IModelGenerator modelGenerator)
        {
            _formService = formService ?? throw new ArgumentNullException(nameof(formService));
            _textQuestionService = textQuestionService ?? throw new ArgumentNullException(nameof(textQuestionService));
            _optionQuestionService = optionQuestionService ?? throw new ArgumentNullException(nameof(optionQuestionService));
            _documentQuestionService = documentQuestionService ?? throw new ArgumentNullException(nameof(documentQuestionService));
            _responseService = responseService ?? throw new ArgumentNullException(nameof(responseService));
            _factory = factory ?? throw new ArgumentNullException(nameof(factory));
            _modelGenerator = modelGenerator ?? throw new ArgumentNullException(nameof(factory));
            _mapper = mapper ?? throw new ArgumentNullException(nameof(mapper));
        }
        [HttpPost]
        public async Task<IActionResult> SubmitResponse(ResponseViewModel response)
        {
            string _errorMessage = Validator.ResponseValidation_Message(response);
            if (_errorMessage != null)
            {
                Response.StatusCode = (int)System.Net.HttpStatusCode.BadRequest;
                return Json(new { success = false, responseText = _errorMessage });
            }
            var responseId = await _responseService.CreateResponseAsync(response.FormId);

            await _factory.CreateTextQuestionResponse(response, responseId, _textQuestionService);
            await _factory.CreateOptionQuestionResponse(response, responseId, _optionQuestionService);
            await _factory.CreateDocumentQuestionResponse(response, responseId, _documentQuestionService);
            return Ok();
        }

        [Route("ViewAnswers/{formId}")]
        public async Task<IActionResult> ViewAnswers(Guid formId)
        {
            var result = await this._responseService.RetrieveResponseForFormAsync(formId);
            var vm = _mapper.Map<FormViewModel>(result);
            return View("ViewAnswersView",vm);
        }

        [Route("Response/{formId}")]
        public async Task<IActionResult> DisplayForm(Guid formId)
        {
            var form = await this._formService.GetFormAsync(formId);
            var formVM = _mapper.Map<FormViewModel>(form);

            var textQuestionsVM = _mapper.Map<ICollection<QuestionViewModel>>(form.TextQuestions);
            var optionQuestionsVM = _mapper.Map<ICollection<QuestionViewModel>>(form.OptionQuestions);
            var documentQuestionsVM = _mapper.Map<ICollection<QuestionViewModel>>(form.DocumentQuestions);

            SetQuestionType(QuestionType.Text, formVM, textQuestionsVM);
            SetQuestionType(QuestionType.Option, formVM, optionQuestionsVM);
            SetQuestionType(QuestionType.Document, formVM, documentQuestionsVM);

            ResponseViewModel response = new ResponseViewModel();
            response.FormId = formVM.Id;
            response.Title = formVM.Title;
            response.Description = formVM.Description;
            response.Questions = formVM.Questions.OrderBy(q=>q.OrderNumber).ToList();

            return View("DisplayFormView", response);
        }
        private void SetQuestionType(QuestionType type, FormViewModel formVM, ICollection<QuestionViewModel> questions)
        {
            if (questions != null)
            {
                foreach (var question in questions)
                {
                    if(type == QuestionType.Option)
                    {
                        for (int i = 0; i < question.Options.Count; i++)
                        {
                            question.OptionQuestionAnswerCheckbox.Add(false);
                        }
                    }
                    question.Type = type;
                }
                formVM.Questions.AddRange(questions);
            }
        }

        [Route("RetrieveResponse/{responseId}")]
        public async Task<IActionResult> RetrieveResponse(Guid responseId, Guid formId)
        {
            var formDTO = await _responseService.RetrieveResponseAsync(responseId, formId);
            var vm = new ResponseDisplayModel();
            vm.Title = formDTO.Title;
            vm.Description = formDTO.Description;
            _modelGenerator.Response_TextRelationship(formDTO, vm);
            _modelGenerator.Response_OptionRelationship(formDTO, vm);
            _modelGenerator.Response_DocumentRelationship(formDTO, vm);

            return View("DisplayResponseView", vm);
        }
    }
}

AlphaMetrixForms/AlphaMetrixForms.Web/Controllers/UserController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Claims;
using System.Threading.Tasks;
using AlphaMetrixForms.Services.Contracts;
using AlphaMetrixForms.Services.DTOs;
using AlphaMetrixForms.Web.Models.Form;
using AlphaMetrixForms.Web.Models.User;
using AlphaMetrixForms.Web.Utils;
using AutoMapper;
using Microsoft.AspNetCore.Mvc;

namespace AlphaMetrixForms.Web.Controllers
{
    public class UserController : Controller
    {

        private readonly IUserService _service;
        private readonly IMapper _mapper;
        private readonly IFormService _formService;
        public UserController(IUserService service, IFormService formService, IMapper mapper)
        {
            _mapper = mapper ?? throw new ArgumentNullException(nameof(mapper));
            _service = service ?? throw new ArgumentNullException(nameof(mapper));
            _formService = formService ?? throw new ArgumentNullException(nameof(mapper));
        }
        public IActionResult Index()
        {
            return View();
        }
        public async Task<IActionResult> Account()
        {
            Guid userId = Guid.Parse(this.User.FindFirstValue(ClaimTypes.NameIdentifier));

            UserDTO user = await _service.UserDetails(userId, _mapper);
            if (user == null)
                return RedirectToAction("Error");

            UserViewModel toPass = _mapper.Map<UserViewModel>(user);
            return View("AccountView", toPass);
        }
        public async Task<IActionResult> MyForms(int? pageNumber)
        {
            Guid userId = Guid.Parse(this.User.FindFirstValue(ClaimTypes.NameIdentifier));
            IEnumerable<FormDTO> forms = await _service.MyForms(userId, _mapper);
            IEnumerable<FormViewModel>  result = _mapper.Map<IEnumerable<FormViewModel>>(forms);


            int pageSize = 9;
            return View("MyFormsView", PaginatedList<FormViewModel>.CreateAsync(result.Reverse(), pageNumber ?? 1, pageSize));
        }
    }
}

AlphaMetrixForms/AlphaMetrixForms.Web/Views/Shared/_DisplayPreviewPartial.cshtml
@model AlphaMetrixForms.Web.Models.Form.FormViewModel


@{
    ViewData["Title"] = "Submit Answer";
}

<link rel="stylesheet" href="~/css/center-card.css" />

<div class="card card col-10 shadow-lg p-3 mb-5 bg-white rounded">
    <div class="card-header">
        <h3>@Model.Title</h3>
    </div>
    <div class="card-body">
        <div class="col-md-6">
            <form id="form" enctype="multipart/form-data" asp-controller="Response" asp-action="SubmitResponse">
                <input type="hidden" asp-for="@Model.Title" />
                <h6>@Model.Description</h6>
                <input type="hidden" asp-for="@Model.Description" />
                <div id="questions">
                    @Html.EditorFor(model => model.Questions)
                </div>
            </form>
        </div>
    </div>
</div>
<br>
<br>
<br>

AlphaMetrixForms/AlphaMetrixForms.Web/Views/Shared/_DocumentQuestionsAnswerPartialView.cshtml
@model AlphaMetrixForms.Web.Models.Question.QuestionViewModel

@{
    int orderNum = Model.OrderNumber + 1;
    string text = $"{orderNum}. {Model.Text}";
}
<br>
<div class="card card col-10 shadow-lg p-3 mb-5 bg-white rounded" id="documentCard">
    <div class="card-header">
        <label for="Title">@text</label>
    </div>
    <div class="card-body" enctype="multipart/form-data">
        <div class="col-md-12">
            <div class="form-group">
                <p>Upload one or more files:</p>
                @if (Model.PreviewMode)
                {
                    <input asp-for="DocumentAnswer" type="file" multiple disabled />
                }
                else
                {
                    <input asp-for="DocumentAnswer" type="file" multiple />
                }
                <span asp-validation-for="DocumentAnswer"></span>
                <p>File size limit: @Model.FileSizeLimit</p>
                <p>File number limit: @Model.FileNumberLimit</p>
            </div>
            <input type="hidden" asp-for="@Model.Id">
            <input type="hidden" asp-for="@Model.Type">
            <input type="hidden" asp-for="@Model.IsRequired">
            <input type="hidden" asp-for="@Model.OrderNumber">
            <input type="hidden" asp-for="@Model.FileNumberLimit">
            <input type="hidden" asp-for="@Model.FileSizeLimit">
        </div>
    </div>
</div>

AlphaMetrixForms/AlphaMetrixForms.Web/Views/Shared/_DocumentQuestionsPartialView.cshtml
@model AlphaMetrixForms.Web.Models.Question.QuestionViewModel

<br>
<div class="card card col-10 shadow-lg p-3 mb-5 bg-white rounded" id="documentCard">
    <div class="card-header">
        Document Question
        <button id="@Model.OrderNumber" name="deleteQuestion" type="button" class="close" aria-label="Close">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="card-body">
        <div class="col-md-12">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="Text" class="control-label"></label>
                <input asp-for="Text" class="form-control" placeholder="Type document question here..." />
                <span asp-validation-for="Text" class="text-danger"></span>
            </div>
            <select asp-for="FileNumberLimit" class="browser-default custom-select col-md-4" id="fileNumber">
                <option selected>File number limit</option>
                <option value="1">1</option>
                <option value="2">2</option>
                <option value="3">3</option>
                <option value="4">4</option>
                <option value="5">5</option>
                <option value="6">6</option>
                <option value="7">7</option>
                <option value="8">8</option>
                <option value="9">9</option>
                <option value="10">10</option>
            </select>
            <select asp-for="FileSizeLimit" class="browser-default custom-select col-md-4" id="fileLimit">
                <option selected>File size limit</option>
                <option value="1">1 MB</option>
                <option value="10">10 MB</option>
                <option value="100">100 MB</option>
                <option value="1000">1 GB</option>
            </select>

            <div class="custom-control custom-switch float-right" style="display: flex; justify-content: space-around">
                <input asp-for="IsRequired" type="checkbox" class="custom-control-input" id="@Model.OrderNumber + document1">
                <label class="custom-control-label" for="@Model.OrderNumber + document1">Required</label>
            </div>
        </div>
    </div>
</div>


<br>

@Html.Hidden("OrderNumber", Model.OrderNumber)
@Html.Hidden("Id", Model.Id)
@Html.Hidden("Type", Model.Type)
@Html.Hidden("EditMode", Model.EditMode)


<script>
    $("button[name='deleteQuestion']").on('click', function () {
        $(this).parent().parent().remove();
        let orderNumber = $(this).attr('id');
        document.getElementById('Current').value = orderNumber;
        $.ajax({
            async: true,
            data: $('#form').serialize(),
            type: "POST",
            url: '/Form/DeleteQuestion',
            success: function (partialView) {
                $('#detailsContainer').empty();
                $('#detailsContainer').html(partialView);
            }
        });
    });
</script>

AlphaMetrixForms/AlphaMetrixForms.Web/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>

    <link rel="stylesheet" href="~/css/particles-background.css">

    <!-- AJAX file upload plugin -->
    <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.7/jquery.js"></script>
    <script src="http://malsup.github.com/jquery.form.js"></script>


    <!-- bootstrap 4.x is supported. You can also use the bootstrap css 3.3.x versions -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" crossorigin="anonymous">
    <link href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-fileinput/5.0.1/css/fileinput.min.css" media="all" rel="stylesheet" type="text/css" />
    <!-- if using RTL (Right-To-Left) orientation, load the RTL CSS file after fileinput.css by uncommenting below -->
    <!-- link href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-fileinput/5.0.1/css/fileinput-rtl.min.css" media="all" rel="stylesheet" type="text/css" /-->
    <!-- the font awesome icon library if using with `fas` theme (or Bootstrap 4.x). Note that default icons used in the plugin are glyphicons that are bundled only with Bootstrap 3.x. -->
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.5.0/css/all.css" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.3.1.min.js" crossorigin="anonymous"></script>
    <!-- piexif.min.js is needed for auto orienting image files OR when restoring exif data in resized images and when you
        wish to resize images before upload. This must be loaded before fileinput.min.js -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-fileinput/5.0.1/js/plugins/piexif.min.js" type="text/javascript"></script>
    <!-- sortable.min.js is only needed if you wish to sort / rearrange files in initial preview.
        This must be loaded before fileinput.min.js -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-fileinput/5.0.1/js/plugins/sortable.min.js" type="text/javascript"></script>
    <!-- purify.min.js is only needed if you wish to purify HTML content in your preview for
        HTML files. This must be loaded before fileinput.min.js -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-fileinput/5.0.1/js/plugins/purify.min.js" type="text/javascript"></script>
    <!-- popper.min.js below is needed if you use bootstrap 4.x (for popover and tooltips). You can also use the bootstrap js
       3.3.x versions without popper.min.js. -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js"></script>
    <!-- bootstrap.min.js below is needed if you wish to zoom and preview file content in a detail modal
        dialog. bootstrap 4.x is supported. You can also use the bootstrap js 3.3.x versions. -->
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>
    <!-- the main fileinput plugin file -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-fileinput/5.0.1/js/fileinput.min.js"></script>
    <!-- following theme script is needed to use the Font Awesome 5.x theme (`fas`) -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-fileinput/5.0.1/themes/fas/theme.min.js"></script>
    <!-- optionally if you need translation for your language then include the locale file as mentioned below (replace LANG.js with your language locale) -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-fileinput/5.0.1/js/locales/LANG.js"></script>




    @*Validation*@
    @*<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-validate/1.19.1/jquery.validate.min.js"></script>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-validation-unobtrusive/3.2.11/jquery.validate.unobtrusive.min.js"></script>*@

    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - AlphaMetrixForms.Web</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />



    @*Sweet alerts*@
    <script src="https://unpkg.com/sweetalert/dist/sweetalert.min.js"></script>


    @*Alerts*@
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css">

    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js">
    </script>

    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js">
    </script>

    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js">
    </script>


    @*Client-side validation*@
    @*<script src="https://ajax.aspnetcdn.com/ajax/jQuery/jquery-2.2.0.min.js"></script>
           <script src="https://ajax.aspnetcdn.com/ajax/jquery.validate/1.16.0/jquery.validate.min.js"></script>
           <script src="https://ajax.aspnetcdn.com/ajax/jquery.validation.unobtrusive/3.2.6/jquery.validate.unobtrusive.mi
        n.js"></script>*@


    <link rel="stylesheet" href="~/css/border-resharper.css" />

</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container">
                @*<a href="@Url.Action("Index", "Home")" class="navbar-brand">
                    <img src="~/assets/img/AlphaMetrixLogoWhite.png" title="title" alt="additional title">
                </a>*@
                @*@Html.ActionLink("Application name", "Index", "Home", null, new { @class = "navbar-brand" })*@
                <a href="/Home/Index" class="navbar-brand"> <img src="~/assets/img/AlphaMetrixLogo11.png" alt="Company logo" width="130" height="40" /></a>

                @*<a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index"></a>*@
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex flex-sm-row-reverse">

                    <partial name="_LoginPartial" />

                    @if (User.Identity.IsAuthenticated)
                    {
                        <a class="nav-link text-dark" asp-controller="Form" asp-action="Create">Create</a>
                        <a class="nav-link text-dark" asp-area="" asp-controller="User" asp-action="MyForms">My Forms</a>
                    }
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="ContactUs">Contact</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Form" asp-action="Index">Forms</a>
                        </li>
                        <li class="nav-item">
                            <partial name="_SearchPartial" />
                        </li>

                    </ul>

                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>


    @*<footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2020 - AlphaMetrixForms.Web - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>*@
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @RenderSection("Scripts", required: false)
    <!-- Syncfusion Essential JS 2 ScriptManager -->
    <ejs-scripts></ejs-scripts>
</body>
</html>

AlphaMetrixForms/AlphaMetrixForms.Web/Views/Shared/_SearchPartial.cshtml
<!-- Search form -->
<form asp-controller="Form" asp-action="SearchForms" id="navBarSearchForm" class="form-inline d-flex justify-content-center md-form form-sm active-cyan active-cyan-2 mt-2">
    <i class="fas fa-search" aria-hidden="true"></i>
<input name="title" class="form-control form-control-sm ml-3 w-75" id="searchInput" type="text" placeholder="Search"
    aria-label="Search">
    </form>
<style>
    #navBarSearchForm input[type=text] {
        width: 300px !important;
    }
</style>